88x2bu-20210702/remove-driver.sh

95 lines
2.2 KiB
Bash
Raw Normal View History

2021-10-27 12:51:22 -05:00
#!/bin/bash
2022-08-21 15:31:50 -05:00
# Purpose: Remove Realtek USB WiFi adapter drivers.
#
# Supports dkms and non-dkms removals.
2022-08-21 15:31:50 -05:00
2021-10-27 12:51:22 -05:00
SCRIPT_NAME="remove-driver.sh"
SCRIPT_VERSION="20221007"
MODULE_NAME="88x2bu"
2022-10-19 16:15:30 -05:00
DRV_VERSION="5.13.1"
OPTIONS_FILE="${MODULE_NAME}.conf"
KVER="$(uname -r)"
KSRC="/lib/modules/${KVER}/build"
MODDESTDIR="/lib/modules/${KVER}/kernel/drivers/net/wireless/"
2022-10-19 16:15:30 -05:00
DRV_NAME="rtl${MODULE_NAME}"
2021-12-14 07:09:23 -06:00
DRV_DIR="$(pwd)"
2022-10-19 16:15:30 -05:00
BLACKLIST_FILE="rtw88_8822bu.conf"
# check to ensure sudo was used
if [[ $EUID -ne 0 ]]
then
echo "You must run this script with superuser (root) privileges."
echo "Try: \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2021-12-14 07:09:23 -06:00
# support for NoPrompt allows non-interactive use of this script
NO_PROMPT=0
2021-12-14 07:09:23 -06:00
# get the options
while [ $# -gt 0 ]
do
2021-12-14 07:09:23 -06:00
case $1 in
NoPrompt)
NO_PROMPT=1 ;;
*h|*help|*)
echo "Syntax $0 <NoPrompt>"
echo " NoPrompt - noninteractive mode"
echo " -h|--help - Show help"
exit 1
;;
esac
shift
done
# displays script name and version
echo "Running ${SCRIPT_NAME} version ${SCRIPT_VERSION}"
2021-10-27 12:51:22 -05:00
echo "Starting removal..."
if ! command -v dkms >/dev/null 2>&1
then
make uninstall
else
dkms remove -m ${DRV_NAME} -v ${DRV_VERSION} --all
fi
2021-10-27 12:51:22 -05:00
RESULT=$?
# RESULT will be 3 if there are no instances of module to remove
# however we still need to remove various files or the install script
# may complain.
2021-10-27 12:51:22 -05:00
if [[ ("$RESULT" = "0")||("$RESULT" = "3") ]]
then
echo "Deleting ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
2022-08-21 15:31:50 -05:00
echo "Deleting ${BLACKLIST_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${BLACKLIST_FILE}
2021-10-27 12:51:22 -05:00
echo "Deleting source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
2022-10-19 16:15:30 -05:00
# echo "Removing a non-dkms installation."
rm -f ${MODDESTDIR}${MODULE_NAME}.ko
/sbin/depmod -a ${KVER}
2021-10-27 12:51:22 -05:00
echo "The driver was removed successfully."
2021-12-14 07:09:23 -06:00
echo "You may now delete the driver directory if desired."
2021-10-27 12:51:22 -05:00
else
echo "An error occurred. dkms remove error = ${RESULT}"
echo "Please report this error."
exit $RESULT
fi
# if NoPrompt is not used, ask user some questions to complete removal
if [ $NO_PROMPT -ne 1 ]
2021-12-14 07:09:23 -06:00
then
read -p "Do you want to reboot now? (recommended) [y/N] " -n 1 -r
echo
if [[ $REPLY =~ ^[Yy]$ ]]
then
reboot
fi
2021-10-27 12:51:22 -05:00
fi
exit 0